/**
  Ufo muss gelandet werden
  "b" Vertikale Rakete
  "n" Rakete nach links
  "v" Rakete nach rechts
 */

int XSIZE = 800;
int YSIZE = 600;
 
float hoehe;            // Höhe in pixeln über dem unteren Fensterrand
float speedV, speedH;   // Verikale und hotrizontale Geschwindigkeit
float position;           // Anfangsposition des Ufos
int platformPos;        // Position der Platform
char rocket;            // Gedrückte Bremstaste
int sprit;

// Setup wird nur einmal am Anfang ausgeführt
void setup() {
  size(XSIZE, YSIZE);
  background(0);        // Schwarzer Hintergrund
  position = int(random(50, XSIZE-50));     // Zufällige Anfangsposition des Ufos
  hoehe=YSIZE-40;
  platformPos = int(random(50,XSIZE-50));   // Zufällige Anfngsposition der Plattform
  platform(platformPos);
  speedV = 0.1;      // Ganz langsame Anfangsgeschwindigkeit des Ufos nach unten
  speedH = 0;        // Keine Horizontalgeschwindigkeit
  sprit = 300;
}
 
// Draw wird 30mal pro Sekunde ausgeführt - das ist der GameLoop 
void draw() {
  if (!gameOver()) {     // Nur ausführen, wenn das Spiel noch läuft
    background(0);   // Bildschirm löschen
    hoehe = hoehe - speedV;      // Höhe um den Speedfaktor verringern
    speedV = speedV + 0.01;      // Speed langsam bei jedem Durchlauf erhöhen
    position = position + speedH;
    spritAnzeige(sprit);
  }
  platform(platformPos);  // Platform zeichnen
  ufo(int(position),YSIZE-int(hoehe),true,rocket);   // Ufo zeichnen
  rocket=' ';
}


// Ufo zeichnen 
void ufo(int posX, int posY, boolean sichtbar, char rocket) {
  if (sichtbar) {
    stroke(0);
    strokeWeight(1);
    fill(100,100,100);
    ellipse(posX, posY-10, 30, 30);
    fill(0,255,0);
    ellipse(posX, posY-10, 15, 20);
    fill(0,0,255);
    ellipse(posX,posY,60,20);
    fill(0);
    ellipse(posX-3,posY-15,2,2);
    ellipse(posX+3,posY-15,2,2);
    stroke(100);
    strokeWeight(3);
    line(posX-20, posY+10, posX-25, posY+20);
    line(posX+20, posY+10, posX+25, posY+20);
    stroke(255,0,0);
    strokeWeight(3);
    if (rocket=='b') line(posX, posY+10, posX, posY+20);   // roten Strich für Raketenflamme zeichnen
    if (rocket=='v') line(posX, posY+10, posX+10, posY+20);
    if (rocket=='n') line(posX, posY+10, posX-10, posY+20);
  } else {
    fill(0);     // Schwarzen Kasten malen, wenn Ufo gelöscht werden soll
    stroke(0);
    rect(posX-32, posY-42, 64, 64); 
  }
}  


// Landeplattform zeichnen am unteren Bildschirmrand
void platform(int xpos) {
  stroke(255);
  strokeWeight(3);
  line(xpos-40, YSIZE-20, xpos+40, YSIZE-20);
  line(xpos-20, YSIZE-20, xpos-20, YSIZE);
  line(xpos+20, YSIZE-20, xpos+20, YSIZE);
}

void spritAnzeige(int wert) {
  stroke(255);
  strokeWeight(1);
  fill(0);
  rect(10,30,20,300);   // Äußeres Rechteck zeichnen
  fill(0,255,0);
  rect(10,330-wert,20,wert);
}

// ===== Spielende Check ====== 
// True - Speil ist beendet
// False- Spiel geht weiter
// Das Spiel endet, wenn das Ufo einen der Ränder des Bildschirms überschreitet
boolean gameOver() {
  boolean state=true;
  
  if ((position>XSIZE)||(position<0)) bad();
  else
  if (hoehe>YSIZE) bad();
  else
  if ((hoehe<10)&&(abs(position-platformPos)>15)) bad();
  else
  if ((hoehe<40)&&(abs(position-platformPos)<15)&&(speedV<2)) good();
  else
  if ((hoehe<40)&&(abs(position-platformPos)<15)&&(speedV>=2)) bad();
  else state=false;
  return(state); 
}

// Gelbe "Korona" umd das Raumschiff zeichnen, wenn die Landung geglückt ist
void good() {
  strokeWeight(0);
  fill(255,255,0,40);
  ellipse(int(position), YSIZE-int(hoehe), 70, 70);
}

// Rotes Kreuz zeichnen, wenn die Landung nicht geglückt ist
void bad()
{
  stroke(255,0,0);
  strokeWeight(10);
  line(0,0,XSIZE,YSIZE);
  line(XSIZE,0,0,YSIZE);
}  

// Von Processing reservierte Call-Back Funktion, die immer dann aufgerufen wird, 
// wenn eine Taste gedrückt wird.
void keyPressed()
{
  if (sprit>0) {
    rocket=key; 
    if (key=='b') {
      speedV=speedV-0.1;                 // b = senkrecht bremsen
      sprit -= 2;
    }
    if (key=='v') {                      // v = bremsen und nach links beschleunigen
      speedV=speedV-0.1;
      speedH=speedH-0.1;
      sprit -= 3;
    }
    if (key=='n') {                      // n = bremsen und nach rechts beschleunigen
      speedV=speedV-0.1;
      speedH=speedH+0.1;
      sprit -= 3;
    }
  }
  if (key==' ') setup();               // Space Taste = Neues Spiel
}

